/*

  Author(s): Ilja V. Ryndin <support@rusbitech.ru>

  Start date: *

*/

#ifndef FLYFM_ACTIONPLUGIN_H
#define FLYFM_ACTIONPLUGIN_H

#include <QAction>

#include <flyfm/plugin.h>

namespace FlyFM
{

class Entry;
class EntryList;
class ActionPlugin;

//////////////////////////////////////////////////////////////////

class PluginAction : public QAction
{
    Q_OBJECT
public:
    enum Location { ActionMenu, SendMenu, ToolBar, ToolsMenu };

    PluginAction(const QIcon& icon, const QString& text, Location location, ActionPlugin* parent);
    virtual ~PluginAction();

    Location location() const;
    virtual bool isAllowedFor(const EntryList&) = 0;
    virtual void call(const Entry &parentEntry, const EntryList &entries) = 0;

protected:
    Location m_location;
};

typedef QList<PluginAction*> PluginActionPtrList;

//////////////////////////////////////////////////////////////////

class ActionPlugin : public Plugin
{
public:
    ActionPlugin();
    virtual ~ActionPlugin();

    virtual PluginActionPtrList actions() = 0;
    virtual QObject* toQObject() = 0;
};

}

Q_DECLARE_INTERFACE(FlyFM::ActionPlugin, "ru.rusbitech.fly-fm.ActionPlugin/1.0")

#endif // FLYFM_ACTIONPLUGIN_H
