/*

  Author(s): Ilja V. Ryndin <support@rusbitech.ru>

  Start date: *

*/

#ifndef FLYFM_COREPLUGINSMANAGER_H
#define FLYFM_COREPLUGINSMANAGER_H

#include <QHash>

#include <flyfm/singletone.h>

namespace FlyFM
{

class PropsPlugin;

class CorePluginsManager : public Singletone
{
public:
    static CorePluginsManager *ptr();
    virtual ~CorePluginsManager();

    QList<PropsPlugin*> propsPlugins() const;
    QString pluginFileName(PropsPlugin* propsPlugin) const;

    void release() Q_DECL_OVERRIDE;

protected:
    CorePluginsManager();

    QList<PropsPlugin*> m_propsPlugins;
    QHash<PropsPlugin*, QString> m_pluginsFileNames;
};

}

#endif // FLYFM_COREPLUGINSMANAGER_H
