/*

  Author(s): Ilja V. Ryndin <support@rusbitech.ru>

  Start date: *

*/

#ifndef FLYFMDESKTOP_H
#define FLYFMDESKTOP_H

#include <flyfm/entry.h>
#include <flyfm/serviceinterfacesingletone.h>

namespace FlyFM
{

class Desktop : public QObject, public ServiceInterfaceSingletone
{
    Q_OBJECT
public:
    static Desktop *ptr();
    ~Desktop();

    int callDesktop();
    int callControlDialog();
    int callRegularWindow(const Entry &startEntry = Entry(), bool isMountPoint = false);

protected:
    Desktop(QObject *parent = 0);
    static Desktop *m_ptr;

private:
    QWeakPointer<QDBusInterface> m_interface;
};

}

#endif // FLYFMDESKTOP_H
