/*

  Author(s): Ilja V. Ryndin <support@rusbitech.ru>

  Start date: *

*/

#ifndef FLYFMENTRYDESCRIBETHREAD_H
#define FLYFMENTRYDESCRIBETHREAD_H

#include <flyfm/entrylist.h>
#include <flyfm/thread.h>
#include <flyfm/loadingstatusstring.h>

class QTimer;

namespace FlyFM
{
class TextDigestEnumerator;

class EntryDescribeThread : public Thread
{
    Q_OBJECT
public:
    EntryDescribeThread(QObject *parent = 0);
    virtual ~EntryDescribeThread();

    void describe(const EntryList &entries);
    void stop();

signals:
    void descriptionUpdated(const QString &data);

protected slots:
    void finished();
    void relaxationTimeout();
    void animationTimeout();

protected:
    virtual void run();

    QString m_text;
    EntryList m_entries;
    bool m_isProcessing;

    TextDigestEnumerator *m_pTextDigestEnumerator;
    QTimer *m_pRelaxationTimer;
    QTimer *m_animationTimer;
    LoadingStatusString m_loadingString;

    friend class Props;
};
}

#endif // FLYFMENTRYDESCRIBETHREAD_H
