/*

  Author(s): Ilja V. Ryndin <support@rusbitech.ru>

  Start date: *

*/

#ifndef FLYFMENTRYENUMERATOR_H
#define FLYFMENTRYENUMERATOR_H

#include <flyfm/entrylist.h>

namespace FlyFM
{

class EntryEnumerator
{
public:
    EntryEnumerator();
    virtual ~EntryEnumerator();

    bool includeSubdirs() const;
    bool includeHidden() const;

public slots:
    void setStartEntry(const Entry &entry);
    Entry nextEntry();

    void setIncludeSubdirs(bool on = true);
    void setIncludeHidden(bool on = true);

protected:
    Entry getNextEntry();

    QList<EntryList> m_backList;
    Entry m_startEntry;
    bool m_includeSubdirs;
    bool m_includeHidden;
};

}

#endif // FLYFMENTRYENUMERATOR_H
