#ifndef FLYFM_GUIAUTHENTICATOR_H
#define FLYFM_GUIAUTHENTICATOR_H

#include <QString>
#include <QMap>

#include <flyfm/authenticator.h>

class QWidget;

namespace FlyFM
{

class GuiAuthenticator : public Authenticator
{
public:
    GuiAuthenticator(QWidget* parent);

    QString getAuth(bool allowUserInteraction, const QString& authTitle, const QString& authMessage,
                    QString *user, bool* userChanged, bool* cancelled) Q_DECL_OVERRIDE;
    void clearPassword(const QString& user) Q_DECL_OVERRIDE;
    void approveLastPassword() Q_DECL_OVERRIDE;

    bool yesNoQuestion(const QString& title, const QString& question) Q_DECL_OVERRIDE;

private:
    void setAuth(const QString& user, const QString& password);
    void tryGetAuths();

    QWidget* m_parentWidget;

    QString m_lastUser;
    QString m_lastPassword;

    bool m_authsInited;
    QMap<QString, QString> m_auths;
};

}

#endif // FLYFM_GUIAUTHENTICATOR_H
