#ifndef FLYFM_MOUNTURLJOB_H
#define FLYFM_MOUNTURLJOB_H

#include <QString>
#include <QSharedPointer>

#include <flyfm/job.h>

namespace FlyFM
{

class Authenticator;

class MountURLJob : public FlyFM::Job
{
    Q_OBJECT
public:
    enum Error { NoError = 0, NotSambaEntry, LoginCancelled, NoShareEntry, NotInFuseGroup, InternalError };

    explicit MountURLJob(QSharedPointer<Authenticator> authenticator, const QString& url, QObject* parent = 0);
    ~MountURLJob();

    void start() Q_DECL_OVERRIDE;

    QString url() const;
    QString localPath() const;

private slots:
    void smbSubJobFinished(Job* job);
    void ftpSubJobFinished(Job* job);
    void sftpSubJobFinished(Job* job);

private:
    QString m_url;
    QSharedPointer<Authenticator> m_authenticator;
    QString m_localPath;
};

} // namespace FlyFM

#endif // FLYFM_MOUNTURLJOB_H
