/*

  Author(s): Ilja V. Ryndin <support@rusbitech.ru>

  Start date: *

*/

#ifndef FLYFMPROPSDIALOG_H
#define FLYFMPROPSDIALOG_H

#include <flyfm/entrylist.h>
#include <flyfm/dialog.h>

class Ui_PropsDialog;

namespace FlyFM
{
class PropsDialog : public Dialog
{
    Q_OBJECT
public:
    explicit PropsDialog(const EntryList &entries, QWidget *parent = 0);
    virtual ~PropsDialog();

    EntryList entries() const;

protected:
    void changeEvent(QEvent *) Q_DECL_OVERRIDE;

protected slots:
    void pbOkClicked();
    void pbCancelClicked();

    void slotPluginWidgetChanged();
    void slotNameEdited(const QString& name);

private:
    void loadSettings();
    void saveSettings() const;

    void updatePixelMetricForIconLabel();

    EntryList m_entries;
    QString m_initialEntryName;

    ::Ui_PropsDialog *m_pUi;
};
}


#endif // FLYFMPROPSDIALOG_H
