#ifndef FLYFMSERVICEINTERFACESINGLETONE_H
#define FLYFMSERVICEINTERFACESINGLETONE_H

#include <QString>
#include <QSharedPointer>
#include <QScopedPointer>
#include <QList>

#include <flyfm/singletone.h>

class QDBusInterface;

namespace FlyFM
{

class ServiceInterfaceSingletone : public Singletone
{
public:
    ServiceInterfaceSingletone(const QString &service);
    virtual ~ServiceInterfaceSingletone();

    bool isAvailable() const;

    QWeakPointer<QDBusInterface> createInterface(const QString& path, const QString& interface);

    void release() Q_DECL_OVERRIDE;

private:
    QString m_service;
    QList<QSharedPointer<QDBusInterface> > m_interfaces;
    QScopedPointer<QDBusInterface> m_serviceInterface;
};

}

#endif // FLYFMINTERFACESINGLETONE_H
