/*

  Author(s): Ilja V. Ryndin <support@rusbitech.ru>

  Start date: *

*/

#ifndef FLYFMTRASH_H
#define FLYFMTRASH_H

#include <QString>

namespace FlyFM
{
class Entry;
class EntryList;

class Trash
{
public:

    static Trash *ptr();
    virtual ~Trash();

    bool registerFile(const QString &filePath, QString &destPath);
    bool unregisterFile(const QString &filePath);

    QString registeredFilePath(const QString &trashFilePath) const;
    QString actualIconName() const;

    bool hasEntries(const QStringList &urls) const;
    bool isTrash(const QString &url) const;

    bool hasEntries(const EntryList &entries) const;
    bool isTrash(const Entry &entry) const;
    bool isEmpty() const;

protected:

    Trash();

    static Trash *m_ptr;
};
}

#endif // FLYFMTRASH_H
