#ifndef FLYFM_UPDATESMBENTRYJOB_H
#define FLYFM_UPDATESMBENTRYJOB_H

#include <QSharedPointer>

#include <flyfm/job.h>
#include <flyfm/entry.h>

namespace FlyFM
{

class Authenticator;

class UpdateSmbEntryJob : public FlyFM::Job
{
    Q_OBJECT
public:
    enum Error { NoError = 0, NotSambaEntry, LoginCancelled, NoShareEntry, NotInFuseGroup };

    explicit UpdateSmbEntryJob(QSharedPointer<Authenticator> authenticator, const Entry& smbEntry, QObject* parent = 0);

    void start() Q_DECL_OVERRIDE;

    Entry smbEntry() const;

private slots:
    void updateWorkgroupsFinished();
    void updateWorkgroupFinished();
    void updateHostFinished();

    void checkJobFinished(Job* job);
    void slotSharedUpdatedInVFS(const Entry& shareEntry);

private:
    Entry m_smbEntry;
    QSharedPointer<Authenticator> m_authenticator;
};

} // namespace FlyFM

#endif // FLYFM_UPDATESMBENTRYJOB_H
