#ifndef FLYFM_VFSSTORAGEJOBS_H
#define FLYFM_VFSSTORAGEJOBS_H

#include <flyfm/job.h>
#include <flyfm/entry.h>

namespace FlyFM
{

class StoragePlacesManagerProxy;

class VFSStorageJob : public Job
{
    Q_OBJECT
public:
    enum Error { NoError = 0, InternalError, Cancelled };

    VFSStorageJob(const Entry& entry, StoragePlacesManagerProxy* storagePlacesManager, QObject* parent = 0);

    const Entry entry() const
    {
        return m_entry;
    }

protected slots:
    void storageJobFinished(Job* job);

protected:
    Entry m_entry;
    StoragePlacesManagerProxy* m_storagePlacesManager;
};

class VFSStorageMountJob : public VFSStorageJob
{
    Q_OBJECT
public:
    VFSStorageMountJob(const Entry& entry, StoragePlacesManagerProxy* storagePlacesManager, QObject* parent = 0);

    void start() Q_DECL_OVERRIDE;
};

class VFSStorageUnmountJob : public VFSStorageJob
{
    Q_OBJECT
public:
    VFSStorageUnmountJob(const Entry& entry, StoragePlacesManagerProxy* storagePlacesManager, QObject* parent = 0);

    void start() Q_DECL_OVERRIDE;
};

class VFSStorageEjectJob : public VFSStorageJob
{
    Q_OBJECT
public:
    VFSStorageEjectJob(const Entry& entry, StoragePlacesManagerProxy* storagePlacesManager, QObject* parent = 0);

    void start() Q_DECL_OVERRIDE;
};

} // namespace FlyFM

#endif
